train:
  image: tensorflow/tensorflow:2.4.1-gpu
  script:
    - nvidia-smi
    - cd notebooks
    - pip install -r requirements.tensorflow-gpu.txt
    - jupyter nbconvert --to script classify_groups.ipynb
    - apt-get install -y p7zip-full
    - cd ../data
    - 7z x -p${DATA_PASSWORD} gitlab-issues.7z
    - cd ../notebooks
    - python3 classify_groups.py
  artifacts:
    paths:
      - models/
  tags:
    - gpu
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH  
      when: manual
      allow_failure: true

classify:
  image: python:3.8.9-slim
  script:
    - cd scripts
    - pip install -r requirements.txt
    - '[ -z "$START_DATE" ] && echo "No START_DATE provided, defaulting to yesterday" || ARGS="--start-date $START_DATE"'
    - python3 scan_with_api.py $ARGS --config config.yml
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: manual
    - if: $CI_PIPELINE_SOURCE == "schedule" && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

verify-protection:
  image: alpine:3.15
  script:
    - apk add p7zip
    - exit_code=0
    - 7z t -p data/gitlab-issues.7z || exit_code=$?
    - |
      echo "The issues archive must be password protected because it contains confidential issues.
      The preceding command tests the archive using a blank password. It should fail if there's a password.
      If it passes it means the archive is not password protected.
      -----------------------------------------------------------------------------------------------------------
      If this job fails, you MUST purge the archive from the repository to prevent access to confidential issues.
      -----------------------------------------------------------------------------------------------------------
      For instructions see https://docs.gitlab.com/ee/user/project/repository/reducing_the_repo_size_using_git.html#purge-files-from-repository-history"
    - if [ "$exit_code" -eq "0" ]; then exit 1; fi
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: never
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - data/gitlab-issues.7z
